<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
  },
  data() {
    return {
      baseProgressUrl: '/nuxt-images/competition/progress-bars/',
    };
  },
  methods: {
    progressBarAltText(percent: Number) {
      switch (percent) {
        case 0:
          return 'Progress bar that shows the current feature capability as little or no capability';
        case 25:
          return 'Progress bar that shows the current feature capability as basic';
        case 50:
          return 'Progress bar that shows the current feature capability as adequate';
        case 75:
          return 'Progress bar that shows the current feature capability as good';
        case 100:
          return 'Progress bar that shows the current feature capability as comprehensive';
        default:
          return null;
      }
    },
  },
});
</script>

<template>
  <div class="legend-wrapper">
    <SlpTypography variant="heading5-bold">Legend</SlpTypography>
    <div class="legend">
      <div
        v-for="block in data.blocks"
        :key="block.header"
        class="legend__block"
      >
        <SlpTypography variant="body3-bold">{{ block.header }}</SlpTypography>
        <div
          v-for="item in block.items"
          :key="item.label"
          class="legend__item"
          :class="{ placeholder: !item.label }"
        >
          <nuxt-img
            v-if="item.progress !== undefined"
            width="90"
            class="progress"
            :src="`${baseProgressUrl}${item.progress}.svg`"
            :alt="progressBarAltText(item.progress)"
          />
          <SlpTypography variant="body3">{{ item.label }}</SlpTypography>
        </div>
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.legend-wrapper {
  border: 1px solid $color-surface-200;
  border-radius: 4px;
  padding: $spacing-32;
  max-width: 50%;

  @media (max-width: $breakpoint-md) {
    max-width: 100%;
  }
}
.legend {
  display: flex;
  flex-direction: column;
  margin-top: 24px;
  @media (min-width: $breakpoint-md) {
    flex-direction: row;
  }
  &__block {
    display: flex;
    flex-direction: column;
    margin-right: 32px;
    margin-bottom: $spacing-8;
  }
  &__item {
    margin: $spacing-8 0 $spacing-16 0;
    display: flex;
    align-items: center;
    min-height: 30px;
    .progress {
      margin-right: 8px;
    }
    &.placeholder {
      @media (max-width: $breakpoint-md) {
        min-height: 0;
        margin: 0;
      }
    }
  }
}
</style>
